require 'spec_helper'
require 'mosso'

describe Mosso do
  it 'should have a version number' do
    expect(Mosso::VERSION).not_to eq(nil)
    expect(Mosso::VERSION).to eql("0.0.25")
  end

  it 'should measure rightly the execution time' do
    line1 = "Exection Time: "
    line2 = "FileName: "

    # initialize
    measure = Measure.new
    sleep 1
    expect(measure.exection_time.round).to eq(1)
    l1, l2 = measure.to_s.split("\n")
    expect(l1).to match Regexp.new("^#{line1}1+\.\\d+\s\\[sec\\]")
    expect(l2).to match Regexp.new("^#{line2}")

    # exection_time
    sleep 2
    expect(measure.exection_time.round).to eq(3)
    l1, l2 = measure.to_s.split("\n")
    expect(l1).to match Regexp.new("^#{line1}3+\.\\d+\s\\[sec\\]")
    expect(l2).to match Regexp.new("^#{line2}")

    # reset
    measure.reset
    sleep 1
    expect(measure.exection_time.round).to eq(1)
    l1, l2 = measure.to_s.split("\n")
    expect(l1).to match Regexp.new("^#{line1}1+\.\\d+\s\\[sec\\]")
    expect(l2).to match Regexp.new("^#{line2}")

    # start
    measure.start
    sleep 2
    expect(measure.exection_time.round).to eq(2)
    l1, l2 = measure.to_s.split("\n")
    expect(l1).to match Regexp.new("^#{line1}2+\.\\d+\s\\[sec\\]")
    expect(l2).to match Regexp.new("^#{line2}")
  end
end
